"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("./pagemenu.css");
exports.Menu = function (p) {
    var title = p.title, _a = p.children, children = _a === void 0 ? [] : _a, className = p.className, onClick = p.onClick;
    return (React.createElement("div", { className: className },
        title &&
            React.createElement("div", { className: "pagemenu-header" },
                React.createElement("div", { className: "pagemenu-title" },
                    React.createElement("h4", null, onClick ?
                        React.createElement("a", { onClick: onClick }, title)
                        : title))),
        React.createElement("div", { className: "pagemenu-body" }, children)));
};
exports.MenuAction = function (p) {
    var title = p.title, icon = p.icon, onClick = p.onClick, className = p.className, children = p.children, disabled = p.disabled;
    var rest = React.Children.toArray(children);
    return (React.createElement("div", { className: (className && className) + " menu-action" },
        React.createElement("a", { className: disabled ? 'disabled' : '', role: "button", onClick: !disabled && onClick },
            React.createElement("div", { className: "pagemenu-action" },
                React.createElement("i", { className: "pagemenu-actionicon material-icons md-18" }, icon),
                React.createElement("span", { className: "pagemenu-actiontitle" }, title))),
        rest &&
            React.createElement("div", { className: "menu-action-children" }, rest)));
};
exports.MenuSeparator = function () {
    return (React.createElement("div", { className: "pagemenu-separator" }));
};
//# sourceMappingURL=pagemenu.js.map